Index: pbx.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx.c,v
retrieving revision 1.222
diff -u -u -r1.222 pbx.c
--- pbx.c	3 Apr 2005 22:24:17 -0000	1.222
+++ pbx.c	16 Apr 2005 18:39:55 -0000
@@ -4872,6 +4872,7 @@
 					ast_verbose(VERBOSE_PREFIX_4 "Channel %s was answered.\n", chan->name);
 
 				if (sync > 1) {
+					ast_mutex_unlock(&chan->lock);
 					if (ast_pbx_run(chan)) {
 						ast_log(LOG_ERROR, "Unable to run PBX on %s\n", chan->name);
 						ast_hangup(chan);
@@ -5042,6 +5043,8 @@
 					strncpy(tmp->data, appdata, sizeof(tmp->data) - 1);
 					tmp->chan = chan;
 					if (sync > 1) {
+						if (locked_channel)
+							ast_mutex_unlock(&chan->lock);
 						ast_pbx_run_app(tmp);
 					} else {
 						pthread_attr_init(&attr);
